Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.aop.framework
Class AbstractSingletonProxyFactoryBean

    java.lang.Object
      org.springframework.aop.framework.ProxyConfig
          org.springframework.aop.framework.AbstractSingletonProxyFactoryBean

All Implemented Interfaces:
  java.io.Serializable, Aware, BeanClassLoaderAware, FactoryBean<java.lang.Object>, InitializingBean

Direct Known Subclasses:
  CacheProxyFactoryBean, TransactionProxyFactoryBean

    public abstract class AbstractSingletonProxyFactoryBean

extends ProxyConfig
implements FactoryBean<java.lang.Object>, BeanClassLoaderAware, InitializingBean

Convenient superclass for `FactoryBean` types that produce singleton-scoped proxy objects.

Manages pre- and post-interceptors (references, rather than interceptor names, as in `ProxyFactoryBean`) and provides consistent interface management.

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  Serialized Form

Constructor Summary
`AbstractSingletonProxyFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`protected abstract java.lang.Object` | `createMainInterceptor()` Create the "main" interceptor for this proxy factory bean.
`protected TargetSource` | `createTargetSource(java.lang.Object target)` Determine a TargetSource for the given target (or TargetSource).
`java.lang.Object` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`java.lang.Class<?>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` | `setAdvisorAdapterRegistry(AdvisorAdapterRegistry advisorAdapterRegistry)` Specify the AdvisorAdapterRegistry to use.
`void` | `setBeanClassLoader(java.lang.ClassLoader classLoader)` Callback that supplies the bean `class loader` to a bean instance.
`void` | `setPostInterceptors(java.lang.Object[] postInterceptors)` Set additional interceptors (or advisors) to be applied after the implicit transaction interceptor.
`void` | `setPreInterceptors(java.lang.Object[] preInterceptors)` Set additional interceptors (or advisors) to be applied before the implicit transaction interceptor, e.g.
`void` | `setProxyClassLoader(java.lang.ClassLoader classLoader)` Set the ClassLoader to generate the proxy class in.
`void` | `setProxyInterfaces(java.lang.Class<?>[] proxyInterfaces)` Specify the set of interfaces being proxied.
`void` | `setTarget(java.lang.Object target)` Set the target object, that is, the bean to be wrapped with a transactional proxy.

Methods inherited from class org.springframework.aop.framework.ProxyConfig
`copyFrom, isExposeProxy, isFrozen, isOpaque, isOptimize, isProxyTargetClass, setExposeProxy, setFrozen, setOpaque, setOptimize, setProxyTargetClass, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### AbstractSingletonProxyFactoryBean

    public AbstractSingletonProxyFactoryBean()

Method Detail

### setTarget

    public void setTarget(java.lang.Object target)

  Set the target object, that is, the bean to be wrapped with a transactional proxy.

  The target may be any object, in which case a SingletonTargetSource will be created. If it is a TargetSource, no wrapper TargetSource is created: This enables the use of a pooling or prototype TargetSource etc.

  See Also:
    `TargetSource`, `SingletonTargetSource`, `LazyInitTargetSource`, `PrototypeTargetSource`, `CommonsPoolTargetSource`

### setProxyInterfaces

    public void setProxyInterfaces(java.lang.Class<?>[] proxyInterfaces)

  Specify the set of interfaces being proxied.

  If not specified (the default), the AOP infrastructure works out which interfaces need proxying by analyzing the target, proxying all the interfaces that the target object implements.

### setPreInterceptors

    public void setPreInterceptors(java.lang.Object[] preInterceptors)

  Set additional interceptors (or advisors) to be applied before the implicit transaction interceptor, e.g. a PerformanceMonitorInterceptor.

  You may specify any AOP Alliance MethodInterceptors or other Spring AOP Advices, as well as Spring AOP Advisors.

  See Also:
    `PerformanceMonitorInterceptor`

### setPostInterceptors

    public void setPostInterceptors(java.lang.Object[] postInterceptors)

  Set additional interceptors (or advisors) to be applied after the implicit transaction interceptor.

  You may specify any AOP Alliance MethodInterceptors or other Spring AOP Advices, as well as Spring AOP Advisors.

### setAdvisorAdapterRegistry

    public void setAdvisorAdapterRegistry(AdvisorAdapterRegistry advisorAdapterRegistry)

  Specify the AdvisorAdapterRegistry to use. Default is the global AdvisorAdapterRegistry.

  See Also:
    `GlobalAdvisorAdapterRegistry`

### setProxyClassLoader

    public void setProxyClassLoader(java.lang.ClassLoader classLoader)

  Set the ClassLoader to generate the proxy class in.

  Default is the bean ClassLoader, i.e. the ClassLoader used by the containing BeanFactory for loading all bean classes. This can be overridden here for specific proxies.

### setBeanClassLoader

    public void setBeanClassLoader(java.lang.ClassLoader classLoader)

  Description copied from interface: `BeanClassLoaderAware`
  Callback that supplies the bean `class loader` to a bean instance.

  Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean's` `InitializingBean.afterPropertiesSet()` method or a custom init-method.

  Specified by:
    `setBeanClassLoader` in interface `BeanClassLoaderAware`
  Parameters:
    `classLoader` - the owning class loader; may be `null` in which case a default `ClassLoader` must be used, for example the `ClassLoader` obtained via `ClassUtils.getDefaultClassLoader()`

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### createTargetSource

    protected TargetSource createTargetSource(java.lang.Object target)

  Determine a TargetSource for the given target (or TargetSource).

  Parameters:
    `target` - target. If this is an implementation of TargetSource it is used as our TargetSource; otherwise it is wrapped in a SingletonTargetSource.
  Returns:
    a TargetSource for this object

### getObject

    public java.lang.Object getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<java.lang.Object>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class<?> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<java.lang.Object>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public final boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<java.lang.Object>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### createMainInterceptor

    protected abstract java.lang.Object createMainInterceptor()

  Create the "main" interceptor for this proxy factory bean. Typically an Advisor, but can also be any type of Advice.

  Pre-interceptors will be applied before, post-interceptors will be applied after this interceptor.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD